using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RFramework;

namespace RFrameGenerate.Model
{
    public partial class T_CR_ProductCrowd : EntityBase<T_CR_ProductCrowd>, ICloneable
    {
        public Guid ProductCrowdGuid{ get;set; }
        public Guid? ProductGuid{ get;set; }   
        public Guid? MerchantGuid{ get;set; }   
        public string ProductName{ get;set; }
        public string ProductImage4{ get;set; }
        public string ProductImage3{ get;set; }
        public string ProductImage2{ get;set; }
        public string ProductImage1{ get;set; }
        public string ProductImage{ get;set; }
        public string Description{ get;set; }
        public decimal UnitPrice{ get;set; }   
        public decimal Price{ get;set; }   
        public int Sort{ get;set; }   
        public bool IsAutoEnable{ get;set; }   
        public int MaxPeriod{ get;set; }   
        public DateTime JoinDate{ get;set; }   
        public Guid? SMerchantGuid{ get;set; }   
        public int? BuyUnitPrice{ get;set; }   
        
        public override string ToString()
        {
            StringBuilder sb = this.EntityToGetKeyValue();
            if (sb == null)
                return base.ToString();
            else
            {
                return sb.ToString();
            }
        }
        
        #region 创建副本
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public object Clone()
        {
            return this.MemberwiseClone();
        }
        /// <summary>
        /// 创建当前 System.Object 的深表副本
        /// </summary>
        /// <returns>返回当前实例的深表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_CR_ProductCrowd DeepClone()
        {
            using (System.IO.Stream objectStream = new System.IO.MemoryStream())
            {
                System.Runtime.Serialization.IFormatter formatter = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
                formatter.Serialize(objectStream, this);
                objectStream.Seek(0, System.IO.SeekOrigin.Begin);
                return formatter.Deserialize(objectStream) as T_CR_ProductCrowd;
            }
        }
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_CR_ProductCrowd ShallowClone()
        {
            return Clone() as T_CR_ProductCrowd;
        }
        #endregion
        
        #region 实体相互转换
        protected override T_CR_ProductCrowd CurrentEntity()
        {
            return this;
        }
        #endregion
    }
}

